# Pretty liberally stolen from RR package here:
# https://src.fedoraproject.org/rpms/rr/blob/rawhide/f/rr.spec

%define gitrev 77f88f4535c5c99a15c6b392fd70209babbcb066
%global asan_dist_prefix /opt/asan-dist
%define _libdir %{asan_dist_prefix}/lib
%define _bindir %{asan_dist_prefix}/bin
%define _datadir %{asan_dist_prefix}/share
%undefine __cmake_in_source_build
%define _unpackaged_files_terminate_build 0
%global __brp_check_rpaths %{nil}

# https://github.com/rr-debugger/rr/issues/3773
%global _lto_cflags %nil
# https://github.com/rr-debugger/rr/issues/3364
%define debug_package %{nil}
%define __strip /bin/true

Name: rr-asan-dist
Version: 5.8.0
Release: 20240712.1%{?dist}
Summary: RR reverse debugger, from latest HEAD
License: MIT
URL: http://rr-project.org
Source: %{gitrev}.tar.gz

# Disable 32-bit builds on architectures with multilibs
# to avoid attempting pulling in 32-bit in to koji build.
%ifarch x86_64
%global disable32bit -Ddisable32bit=ON
%endif

BuildRequires: cmake
BuildRequires: python3-pexpect
BuildRequires: python3
BuildRequires: make gcc gcc-c++ gdb
BuildRequires: libgcc
BuildRequires: glibc-devel
BuildRequires: libstdc++-devel
BuildRequires: man-pages
BuildRequires: capnproto capnproto-libs capnproto-devel
BuildRequires: patchelf
BuildRequires: zlib-devel
BuildRequires: libzstd-devel

# Fixes https://github.com/rr-debugger/rr/issues/3779
Patch0001: 0001-fix-assertion-nbytes-vfork.patch

%description
The RR reverse debugger, revision %{gitrev}. This is a separate
package because I need some fixes from HEAD. Once Fedora catches
up, this package can be nuked from orbit.

%prep
%autosetup -p1 -n rr-%{gitrev}

%build
%cmake -DCMAKE_BUILD_TYPE=Release -DINSTALL_TESTSUITE=ON %{?disable32bit} -DCMAKE_INSTALL_PREFIX=%{asan_dist_prefix} -DCMAKE_INSTALL_LIBDIR=lib
%cmake_build

%install
%cmake_install
mkdir -p %{buildroot}%{_libdir} %{buildroot}%{_bindir} %{buildroot}%{_datadir}

%files
%dir %{_libdir}/rr
%{_libdir}/rr/*.so
%exclude %{_libdir}/rr/libtest_lib*.so
%{_bindir}/rr
%{_bindir}/rr_exec_stub*
%{_bindir}/signal-rr-recording.sh
%{_bindir}/rr-collect-symbols.py
%{_datadir}/bash-completion/completions/rr
%dir %{_datadir}/rr
%{_datadir}/rr/*.xml
%attr(755,root,root) %{_libdir}/rr/*.so

%changelog
* Fri Jul 12 2024 KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au> - 5.8.0-20240712.1
- Fix https://github.com/rr-debugger/rr/issues/3379

* Tue Jul 09 2024 KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au> - 5.8.0-20240709.1
- Fix https://github.com/rr-debugger/rr/issues/3364

* Sun Jul 07 2024 KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au> - 5.8.0-20240707.1
- Use fixed version of rr with LTO disabled

* Tue Jul 02 2024 KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au> - 5.8.0-20240702.1
- Opt out of LTO

* Sun Jun 30 2024 KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au> - 5.8.0-20240630.1
- Use fewer compiler flags

* Sat Jun 29 2024 KJ Tsanaktsidis <kj@kjtsanaktsidis.id.au> - 5.8.0-20240629.1
- Auto-sync with upstream branch release/2.36/master,
